Index: en_US.ISO8859-1/books/handbook/kernelconfig/chapter.xml
===================================================================
--- en_US.ISO8859-1/books/handbook/kernelconfig/chapter.xml	(revision 43745)
+++ en_US.ISO8859-1/books/handbook/kernelconfig/chapter.xml	(working copy)
@@ -204,8 +204,8 @@
       &man.pciconf.8;, which provides more verbose output.  For
       example:</para>
 
-    <programlisting><command>pciconf -lv</command>
-    ath0@pci0:3:0:0:        class=0x020000 card=0x058a1014 chip=0x1014168c rev=0x01 hdr=0x00
+    <programlisting>&prompt.user; pciconf -lv
+ath0@pci0:3:0:0:        class=0x020000 card=0x058a1014 chip=0x1014168c rev=0x01 hdr=0x00
     vendor     = 'Atheros Communications Inc.'
     device     = 'AR5212 Atheros AR5212 802.11abg wireless'
     class      = network
@@ -226,7 +226,7 @@
 ath_hal(4)               - Atheros Hardware Access Layer (HAL)</programlisting>
 
     <para>Once the hardware inventory list is created, refer to it
-      to ensure that installed hardware is not removed as you edit the custom
+      to ensure that drivers for installed hardware are not removed as you edit the custom
       kernel configuration file.</para>
   </sect1>
 
@@ -250,11 +250,7 @@
       <para>If <filename>/usr/src/</filename> does
 	not exist or it is empty, source has not been installed.
 	Source can be installed using
-	<application>svn</application>, which is described in <xref linkend="svn"/>, or by installing the
-	<literal>src</literal> distribution using &man.sysinstall.8;.  This
-	distribution can be selected by navigating to the 
-	<literal>Configuration</literal> and then to the
-	<literal>Distributions</literal> menu within &man.sysinstall.8;.</para>
+	<application>svn</application>, which is described in <xref linkend="svn"/>.</para>
 
     <para>Once source is installed, review the contents of <filename>/usr/src/sys</filename>.  This directory contains a
       number of subdirectories, including those which represent the following
@@ -350,7 +346,7 @@
     <note>
       <para>To build a file which contains all available options,
 	run the following command as <systemitem class="username">root</systemitem>:</para>
-      <screen>&prompt.root; <userinput>cd /usr/src/sys/i386/conf &amp;&amp; make LINT</userinput></screen>
+      <screen>&prompt.root; <userinput>cd /usr/src/sys/<replaceable>arch</replaceable>/conf &amp;&amp; make LINT</userinput></screen>
     </note>
 
 
@@ -521,10 +517,10 @@
     <programlisting>options          SCSI_DELAY=5000  # Delay (in ms) before probing SCSI</programlisting>
 
     <para>This causes the kernel to pause for 5 seconds before probing
-      each SCSI device in the system.  If the system only has IDE hard
-      drives, ignore this or lower the number to speed up booting.
-      However, if &os; has trouble recognizing the SCSI devices, the
-      number will have to be raised again.</para>
+      each SCSI device in the system.  If &os; has trouble recognizing
+      the SCSI devices, the number will have to be raised.  On the
+      other hand, if the system has only IDE hard drives, ignore this
+      or lower the number to speed up booting.</para>
 
     <programlisting>options          KTRACE            # ktrace(1) support</programlisting>
 
@@ -577,7 +573,7 @@
       processors.</para>
 
     <note>
-      <para>This device exists only on the i386 architecture and this
+      <para>This device exists only on the &i386; architecture and this
 	configuration line should not be used on other
 	architectures.</para>
     </note>
@@ -743,8 +739,7 @@
 
     <para>The &man.vga.4; video card driver.</para>
 
-    <programlisting>
-device          splash     # Splash screen and screen saver support</programlisting>
+    <programlisting>device          splash     # Splash screen and screen saver support</programlisting>
 
     <para>Required by the boot splash screen and screen savers.</para>
 
@@ -926,7 +921,7 @@
 #device         le</programlisting>
 
     <para>ISA Ethernet drivers.  See
-      <filename>/usr/src/sys/i386/conf/NOTES</filename>
+      <filename>/usr/src/sys/<replaceable>arch</replaceable>/conf/NOTES</filename>
       for details of which cards are supported by which driver.</para>
 
     <programlisting># Wireless NIC cards
@@ -1065,7 +1060,7 @@
 
     <para>For more information and additional devices supported by
       &os;, see
-      <filename>/usr/src/sys/i386/conf/NOTES</filename>.</para>
+      <filename>/usr/src/sys/<replaceable>arch</replaceable>/conf/NOTES</filename>.</para>
 
     <sect2>
       <title>Large Memory Configurations